package checker;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import lexer.Symbol;
import lexer.LexerGenerator.Token;
import parser.Grammar.NonTerminal;
import parser.Rule;

public class Checker {
	
	private AST ast;
	public AST getAst() {
		return ast;
	}

	/**
	 * Requires a right most analysis from the parser to initiate a new abstract syntax tree.
	 * This tree is then used for subsequent semantic checks.
	 * @param analysis
	 */
	public Checker(List<Symbol> symbols, List<Rule> analysis){
		ast = new AST(symbols, analysis);
	}
	
	/**
	 * Check if every identifier which is used has been declared before.
	 * @return
	 */
	public boolean checkDeclaredBeforeUsed(){
		//TODO
		return false;
	}
	
	private String findDeclaredID(ASTNode node){
		assert(node.getType().equals(NonTerminal.declaration));
		assert(node.getChildren().size() == 2);
		return node.getChildren().get(1).getAttribute();
	}

}
